import re

def neighbors(router, routing_instances=["IAS"], group_expression=None):

    for config in router["bgp"]["configuration"]:
        for ri in config["routing-instances"]:
            for inst in ri["instance"]:
                if inst["name"]["data"] not in routing_instances:
                    continue
                for prot in inst["protocols"]:
                    for bgp in prot.get("bgp", []):
                        for g in bgp.get("group", []):
                            if group_expression and not \
                                    re.match(group_expression, g["name"]["data"]):
                                continue
                            for n in g["neighbor"]:
                                yield n
